<?php 
    /*Feito por Victor Rangel
    Produto Odhen*/
namespace Teknisa\MAN\Controllers;
    
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Services;

class PermissoesNoCash extends \Teknisa\MAN\Controllers\TeknisaCrud { 
    
    protected $dataSourceNameArray = array (
        'permissoes_noCash'   => 'paraNoCash_permissoesNoCash'
    );
    protected $parameterBagColumnsArray = array (
        'permissoes_noCash' =>  array('NRORG')
    );
    
   public function __construct ($crudService, $parameterBag, Manager $dataSourceManager, EntityManager $entityManager, Services\FileUploaderService $fileUploaderService) {
        $this->crudService              = $crudService;
        $this->parameterBag             = $parameterBag;
        $this->dataSourceManager        = $dataSourceManager;
        $this->entityManager            = $entityManager;
        $this->fileUploaderService = $fileUploaderService;
    }
    
    ///find's
    public function findPermissoesNoCash(DTO\Request\Filter $request, DTO\Response $response) {
        $nrorg = $request->getFilterCriteria()->getConditions()[0]['value'];
        
        $params = array(':NRORG' => $nrorg);
        $conteudo  = $this->entityManager->getConnection()->fetchAll(self::VERIFICA_CONTEUDO, $params);
        
        if(empty($conteudo)) {
            $this->entityManager->getConnection()->executeQuery(self::INSERT_PERMISSOES, $params);
        }
        
        $this->dataSourceName = $this->dataSourceNameArray['permissoes_noCash'];
        $this->parameterBagColumns = $this->parameterBagColumnsArray['permissoes_noCash'];
        parent::find($request, $response);
    }
    
    ///save's
    public function savePermissoesNoCash(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['permissoes_noCash'];
        $this->parameterBagColumns = $this->parameterBagColumnsArray['permissoes_noCash'];
        $row = $request->getDataSet()->getRows()[0];
        $this->fileUploaderService->setImageForSave($row, 'DSENDPDF', 'DSENDPDF');
        parent::save($request, $response);
    }
    
    const VERIFICA_CONTEUDO = 'SELECT * FROM PARAMNOCASH WHERE NRORG = :NRORG';
    
    const INSERT_PERMISSOES = "
        INSERT INTO PARAMNOCASH (CONSULTASALDO, CONSULTAEXTRATO, RECARREGACARTAO, BLOQUEACARTAO, RESTRICAOALIMENTAR, ATUALIZACADASTRO, TROCASENHA, VISUALIZACARDAPIO, RESTRICAOVALOR, FALECONOSCO, RECARGAAUTOCARTAO, EDITACARTAO, LOGINCLIENTE, IDATIVO, IDNOTIFICACAOAPP,NRORG)
        VALUES ('S', 'S', 'S', 'S', 'S', 'S', 'S', 'S', 'S', 'S', 'S', 'S', 'S', 'S', 'S', :NRORG)
    ";
}
?>