<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services\RelCampanhaFidelidadeService;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelCampanhaFidelidade  {
    protected $campFideService;
    protected $utilService;
    
    public function __construct (RelCampanhaFidelidadeService $relCampFideService, Utilities\Util $utilService){
        $this->utilService          = $utilService;
        $this->campFideService    = $relCampFideService;
    }
    
    public function consultCampaign(Request $request, Response $response) {
        $result = [];
        $row = $request->getRow();
        
        $CDCAMPANHA = isset($row['CDCAMPANHA']) ? $row['CDCAMPANHA'] : null;
        $dataHoje = date('d/m/Y');
    
        if ($CDCAMPANHA) {
            $dsCampanhaResult = $this->campFideService->getDSCAMPANHA($CDCAMPANHA);
            $result['DSCAMPANHA'] = isset($dsCampanhaResult[0]['DSCAMPANHA']) ? $dsCampanhaResult[0]['DSCAMPANHA'] : null;
    
            $vigCampResult = $this->campFideService->getVIGCAMP($CDCAMPANHA);
            $result['VIGCAMP'] = isset($vigCampResult[0]) ? $vigCampResult[0] : null;
    
            if (isset($result['VIGCAMP'])) {
                $DTINIVIGCAMP = $result['VIGCAMP']["DTINIVIGCAMP"];
                $DTFIMVIGCAMP = $result['VIGCAMP']["DTFIMVIGCAMP"];
                
                $nrConsumidoresResult = $this->campFideService->getNRCONSUMIDORES($CDCAMPANHA, $dataHoje);
                $result["NRCONSUMIDORES"] = isset($nrConsumidoresResult[0]["NRCONSUMIDORES"]) ? $nrConsumidoresResult[0]["NRCONSUMIDORES"] : null;
                
                $vrTotVendasResult = $this->campFideService->getVRTOTVENDAS($CDCAMPANHA, $DTINIVIGCAMP, $DTFIMVIGCAMP);
                $result["VRTOTVENDAS"] = isset($vrTotVendasResult[0]['VRTOTVENDAS']) ? $vrTotVendasResult[0]['VRTOTVENDAS'] : null;
                
                $beneficiadosResult = $this->campFideService->getNRBENEFICIADOS($CDCAMPANHA, $result["NRCONSUMIDORES"], $DTINIVIGCAMP, $DTFIMVIGCAMP);
                $result["BENEFICIADOS"] = isset($beneficiadosResult[0]) ? $beneficiadosResult[0] : null;
                
                $brindeResgResult = $this->campFideService->getNRBRINDERESG($CDCAMPANHA, $DTINIVIGCAMP, $DTFIMVIGCAMP);
                $result["BRINDERESG"] = isset($brindeResgResult[0]) ? $brindeResgResult[0] : null;
            }
        }
    
        $response->addDataSet(new DataSet('relCampanhaFidelidade', $result));
    }
}